;
; Structure and constant definitions for MESSAGE.ASM
;

message_buffer	struc
   MB_reserved	 db 0		; Reserved field used by system call
   MB_type	 db 0		; User defined message type
   MB_machine	 db 16 dup (0)	; Machine name that message is destined for
   MB_server	 db 16 dup (0)	; User must be logged into this server
   MB_user	 db 16 dup (0)	; User must be using this username
   MB_originator db 16 dup (0)  ; Originator's machine name. Filled in
				; when message is received
   MB_text	 db 80 dup (0)	; Message text
message_buffer	ends

field_desc	struc
   FD_index	db 0		; current pointer position in string
   FD_length	db 0		; length of string
   FD_maxlen	db 0		; maximum length of field
   FD_data	dw 0		; offset of string start in current DS
field_desc	ends

MBT_general	equ 0		; General message used by NET.
MBT_warning	equ 1		; Server warning message.

IF1             ;; Macro Definitions
;;** PushAll
@PushAll	MACRO
	push ax
	push bx
	push cx
	push dx
	push bp
	push di
	push si
	push ds
	push es
	pushf
	cld
ENDM

;; *** PopAll
@PopAll	MACRO
	popf
	pop	es
	pop	ds
	pop	si
	pop	di
	pop	bp
        pop	dx
        pop	cx
        pop	bx
        pop	ax
ENDM        

;;** NewStack - switch to new stack context
@NewStack	MACRO
	cli
	mov	cs:new_stk_seg,cs
	mov	cs:old_stk_seg,ss
	mov	cs:old_stk_ptr,sp
	mov	ss,cs:new_stk_seg
	mov	sp,cs:new_stk_ptr
	@PushAll
	sti
ENDM

;; OldStack --
@OldStack	MACRO	
	cli
	@PopAll
	mov	ss,cs:old_stk_seg
	mov	sp,cs:old_stk_ptr
	sti
ENDM

PUTC	MACRO 	char,count
	mov	al,char
	mov	cx,count
	call	PUTCHAR
ENDM	
MOVE_CURSOR	MACRO	row,column
	mov	dh,row
	mov	dl,column
	call	CURSOR
ENDM
DRAW_LINE	MACRO	start,middle,end,row
	mov	al,start
	mov	ah,middle
	mov	bl,end
        mov	bh,row
        call	LINE
	ENDM        

ENDIF	