/* structures and constants for use with LANtastic operating system */
#define TRUE  1
#define FALSE 0

typedef struct msg_buffer {
	char reserved,
	     type,
	     destination[16],
	     server[16],
	     user[16],
	     sender[16],
	     text[80];
  } MSG_BUFFER;
  
typedef struct queue_entry {
	char status;             /* current status */
	unsigned long size;      /* size in bytes */
	char type,               /* type of queue entry */
	     control;            /* output control */
	     int copies;         /* number of copies */
	unsigned long sequence;  /* internal sequence number */
	char path[48],           /* pathname */
	     user[16],           /* originating user */
	     machine[16];        /* originating machine */
	unsigned int date,       /* date and time spooled */
		     time;
	char destination[17],    /* destination user or device */
	     comment[48];        /* comment field */
      } QUEUE_ENTRY;          
	     
typedef struct active_user {
	unsigned int vcid;
	char state,
	     command,
	     io_bytes[5],
	     requests[3],
	     name[16],
	     machine[16];
	 } ACTIVE_USER;     

/* LANOS CONFIGURATION STUFF */
#define REDIR_RUNNING  0x40
#define SERVER_RUNNING 0x08

#define MPB_beep 0x01
#define MPB_deliver 0x02

#define PRINT_DEVICE 3
#define DISK_DEVICE  4

/* queue control stuff */
#define CQ_start     0
#define CQ_halt      1
#define CQ_halt_EOJ  2
#define CQ_pause     3
#define CQ_single    4
#define CQ_restart   5
#define CQ_cancel    6
#define CQ_hold      7
#define CQ_release   8
#define CQ_rush      9

/* assembly language functions */
int nos_present();
int get_inactive_server(char *,int);
int get_active_server(char *,int);
int login(char *);
int logout(char *);
char *get_error_text(int);
int redirect_device(char *,char *,int);
int cancel_redirection(char *);
int whoami(char *);
int get_user_info(char *,int,ACTIVE_USER *);

