
'============================================================================'
'                                                                            '
' Visual Basic global constant file.  This file can be loaded into the       '
' global module.                                                             '
'                                                                            '
' Some constants are commented out because they have duplicates (for         '
' example, NONE appears in several places).                                  '
'                                                                            '
'============================================================================'

'========='
'         '
' General '
'         '
'========='

' Booleans
Global Const TRUE = -1
Global Const FALSE = 0

'=================='
'                  '
' Event parameters '
'                  '
'=================='

' Button and Shift (KeyDown, KeyUp, MouseDown, MouseMove, MouseUp)
Global Const SHIFT_MASK = 1
Global Const CTRL_MASK = 2
Global Const ALT_MASK = 4
Global Const LEFT_BUTTON = 1
Global Const RIGHT_BUTTON = 2
Global Const MIDDLE_BUTTON = 4

' ErrNum (LinkError)
Global Const WRONG_FORMAT = 1
Global Const REQUEST_WITHOUT_INIT = 2
Global Const DDE_WITHOUT_INIT = 3
Global Const ADVISE_WITHOUT_INIT = 4
Global Const POKE_WITHOUT_INIT = 5
Global Const DDE_SERVER_CLOSED = 6
Global Const TOO_MANY_LINKS = 7
Global Const STRING_TOO_LONG = 8
Global Const INVALID_CONTROL_ARRAY_REFERENCE = 9
Global Const UNEXPECTED_DDE = 10
Global Const OUT_OF_MEMORY = 11
Global Const SERVER_ATTEMPTED_CLIENT_OPERATION = 12

' KeyCode (KeyDown, KeyUp)
Global Const KEY_LBUTTON = &H1
Global Const KEY_RBUTTON = &H2
Global Const KEY_CANCEL = &H3
Global Const KEY_MBUTTON = &H4         ' NOT contiguous with L & RBUTTON
Global Const KEY_BACK = &H8
Global Const KEY_TAB = &H9
Global Const KEY_CLEAR = &HC
Global Const KEY_RETURN = &HD
Global Const KEY_SHIFT = &H10
Global Const KEY_CONTROL = &H11
Global Const KEY_MENU = &H12
Global Const KEY_PAUSE = &H13
Global Const KEY_CAPITAL = &H14
Global Const KEY_ESCAPE = &H1B
Global Const KEY_SPACE = &H20
Global Const KEY_PRIOR = &H21
Global Const KEY_NEXT = &H22
Global Const KEY_END = &H23
Global Const KEY_HOME = &H24
Global Const KEY_LEFT = &H25
Global Const KEY_UP = &H26
Global Const KEY_RIGHT = &H27
Global Const KEY_DOWN = &H28
Global Const KEY_SELECT = &H29
Global Const KEY_PRINT = &H2A
Global Const KEY_EXECUTE = &H2B
Global Const KEY_SNAPSHOT = &H2C
Global Const KEY_INSERT = &H2D
Global Const KEY_DELETE = &H2E
Global Const KEY_HELP = &H2F

' KEY_A thru KEY_Z are the same as their ASCII equivalents: 'A' thru 'Z'
' KEY_0 thru KEY_9 are the same as their ASCII equivalents: '0' thru '9'

Global Const KEY_NUMPAD0 = &H60
Global Const KEY_NUMPAD1 = &H61
Global Const KEY_NUMPAD2 = &H62
Global Const KEY_NUMPAD3 = &H63
Global Const KEY_NUMPAD4 = &H64
Global Const KEY_NUMPAD5 = &H65
Global Const KEY_NUMPAD6 = &H66
Global Const KEY_NUMPAD7 = &H67
Global Const KEY_NUMPAD8 = &H68
Global Const KEY_NUMPAD9 = &H69
Global Const KEY_MULTIPLY = &H6A
Global Const KEY_ADD = &H6B
Global Const KEY_SEPARATOR = &H6C
Global Const KEY_SUBTRACT = &H6D
Global Const KEY_DECIMAL = &H6E
Global Const KEY_DIVIDE = &H6F
Global Const KEY_F1 = &H70
Global Const KEY_F2 = &H71
Global Const KEY_F3 = &H72
Global Const KEY_F4 = &H73
Global Const KEY_F5 = &H74
Global Const KEY_F6 = &H75
Global Const KEY_F7 = &H76
Global Const KEY_F8 = &H77
Global Const KEY_F9 = &H78
Global Const KEY_F10 = &H79
Global Const KEY_F11 = &H7A
Global Const KEY_F12 = &H7B
Global Const KEY_F13 = &H7C
Global Const KEY_F14 = &H7D
Global Const KEY_F15 = &H7E
Global Const KEY_F16 = &H7F
Global Const KEY_NUMLOCK = &H90

' State (DragOver)
Global Const ENTER = 0
Global Const LEAVE = 1
Global Const OVER = 2

'====================='
'                     '
' Function parameters '
'                     '
'====================='

' MsgBox parameters
Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const MB_ICONSTOP = 16          ' Critical message
Global Const MB_ICONQUESTION = 32      ' Warning query
Global Const MB_ICONEXCLAMATION = 48   ' Warning message
Global Const MB_ICONINFORMATION = 64   ' Information message

Global Const MB_DEFBUTTON1 = 0         ' First button is default
Global Const MB_DEFBUTTON2 = 256       ' Second button is default
Global Const MB_DEFBUTTON3 = 512       ' Third button is default

' MsgBox return values
Global Const IDOK = 1                  ' OK button pressed
Global Const IDCANCEL = 2              ' Cancel button pressed
Global Const IDABORT = 3               ' Abort button pressed
Global Const IDRETRY = 4               ' Retry button pressed
Global Const IDIGNORE = 5              ' Ignore button pressed
Global Const IDYES = 6                 ' Yes button pressed
Global Const IDNO = 7                  ' No button pressed


'==================='
'                   '
' Method parameters '
'                   '
'==================='

' Drag (controls)
Global Const CANCEL = 0
Global Const BEGIN_DRAG = 1
Global Const END_DRAG = 2

' GetData, GetFormat, SetData (Clipboard)
Global Const CF_LINK = &HBF00
Global Const CF_TEXT = 1
Global Const CF_BITMAP = 2
Global Const CF_METAFILE = 3
Global Const CF_DIB = 8

' Show (form)
Global Const MODAL = 1
Global Const MODELESS = 0

'================='
'                 '
' Property values '
'                 '
'================='

' Alignment (label)
Global Const LEFT_JUSTIFY = 0          ' 0 - Left Justify
Global Const RIGHT_JUSTIFY = 1         ' 1 - Right Justify
Global Const CENTER = 2                ' 2 - Center

' BackColor, ForeColor, FillColor (standard RGB colors: form, controls)
Global Const BLACK = &H0&
Global Const RED = &HFF&
Global Const GREEN = &HFF00&
Global Const YELLOW = &HFFFF&
Global Const BLUE = &HFF0000
Global Const MAGENTA = &HFF00FF
Global Const CYAN = &HFFFF00
Global Const WHITE = &HFFFFFF

' BackColor, ForeColor, FillColor (system colors: form, controls)
Global Const SCROLL_BARS = &H80000000           ' Scroll-bars gray area.
Global Const DESKTOP = &H80000001               ' Desktop.
Global Const ACTIVE_TITLE_BAR = &H80000002      ' Active window caption.
Global Const INACTIVE_TITLE_BAR = &H80000003    ' Inactive window caption.
Global Const MENU_BAR = &H80000004              ' Menu background.
Global Const WINDOW_BACKGROUND = &H80000005     ' Window background.
Global Const WINDOW_FRAME = &H80000006          ' Window frame.
Global Const MENU_TEXT = &H80000007             ' Text in menus.
Global Const WINDOW_TEXT = &H80000008           ' Text in windows.
Global Const TITLE_BAR_TEXT = &H80000009        ' Text in caption, size box, scroll-bar arrow box..
Global Const ACTIVE_BORDER = &H8000000A         ' Active window border.
Global Const INACTIVE_BORDER = &H8000000B       ' Inactive window border.
Global Const APPLICATION_WORKSPACE = &H8000000C ' Background color of multiple document interface (MDI) applications.
Global Const HIGHLIGHT = &H8000000D             ' Items selected item in a control.
Global Const HIGHLIGHT_TEXT = &H8000000E        ' Text of item selected in a control.
Global Const BUTTON_FACE = &H8000000F           ' Face shading on command buttons.
Global Const BUTTON_SHADOW = &H80000010         ' Edge shading on command buttons.
Global Const GRAY_TEXT = &H80000011             ' Grayed (disabled) text.  This color is set to 0 if the current display driver does not support a solid gray color.
Global Const BUTTON_TEXT = &H80000012           ' Text on push buttons.

' BorderStyle (form, label, picture box, text box)
Global Const NONE = 0                  ' 0 - None
Global Const FIXED_SINGLE = 1          ' 1 - Fixed Single
Global Const SIZABLE = 2               ' 2 - Sizable (Forms only)
Global Const FIXED_DOUBLE = 3          ' 3 - Fixed Double (Forms only)

' DragMode (controls)
Global Const MANUAL = 0                ' 0 - Manual
Global Const AUTOMATIC = 1             ' 1 - Automatic

' DrawMode (form, picture box, Printer)
Global Const BLACKNESS = 1             ' 1 - Blackness
Global Const NOT_MERGE_PEN = 2         ' 2 - Not Merge Pen
Global Const MASK_NOT_PEN = 3          ' 3 - Mask Not Pen
Global Const NOT_COPY_PEN = 4          ' 4 - Not Copy Pen
Global Const MASK_PEN_NOT = 5          ' 5 - Mask Pen Not
Global Const INVERT = 6                ' 6 - Invert
Global Const XOR_PEN = 7               ' 7 - Xor Pen
Global Const NOT_MASK_PEN = 8          ' 8 - Not Mask Pen
Global Const MASK_PEN = 9              ' 9 - Mask Pen
Global Const NOT_XOR_PEN = 10          ' 10 - Not Xor Pen
Global Const NOP = 11                  ' 11 - Nop
Global Const MERGE_NOT_PEN = 12        ' 12 - Merge Not Pen
Global Const COPY_PEN = 13             ' 13 - Copy Pen
Global Const MERGE_PEN_NOT = 14        ' 14 - Merge Pen Not
Global Const MERGE_PEN = 15            ' 15 - Merge Pen
Global Const WHITENESS = 16            ' 16 - Whiteness

' DrawStyle (form, picture box, Printer)
Global Const SOLID = 0                 ' 0 - Solid
Global Const DASH = 1                  ' 1 - Dash
Global Const DOT = 2                   ' 2 - Dot
Global Const DASH_DOT = 3              ' 3 - Dash-Dot
Global Const DASH_DOT_DOT = 4          ' 4 - Dash-Dot-Dot
Global Const INVISIBLE = 5             ' 5 - Invisible
Global Const INSIDE_SOLID = 6          ' 6 - Inside Solid

' FillStyle (form, picture box, Printer)
' Global Const SOLID = 0               ' 0 - Solid
Global Const TRANSPARENT = 1           ' 1 - Transparent
Global Const HORIZONTAL_LINE = 2       ' 2 - Horizontal Line
Global Const VERTICAL_LINE = 3         ' 3 - Vertical Line
Global Const UPWARD_DIAGONAL = 4       ' 4 - Upward Diagonal
Global Const DOWNWARD_DIAGONAL = 5     ' 5 - Downward Diagonal
Global Const CROSS = 6                 ' 6 - Cross
Global Const DIAGONAL_CROSS = 7        ' 7 - Diagonal Cross

' LinkMode (controls)
' Global Const NONE = 0                ' 0 - None
Global Const HOT = 1                   ' 1 - Hot
Global Const COLD = 2                  ' 2 - Cold

' LinkMode (form)
' Global Const NONE = 0                ' 0 - None
Global Const SERVER = 1                ' 1 - Server

' MousePointer (form, controls)
Global Const default = 0               ' 0 - Default
Global Const ARROW = 1                 ' 1 - Arrow
Global Const CROSSHAIR = 2             ' 2 - Cross
Global Const IBEAM = 3                 ' 3 - I-Beam
Global Const ICON_POINTER = 4          ' 4 - Icon
Global Const SIZE_POINTER = 5          ' 5 - Size
Global Const SIZE_NE_SW = 6            ' 6 - Size NE SW
Global Const SIZE_N_S = 7              ' 7 - Size N S
Global Const SIZE_NW_SE = 8            ' 8 - Size NW SE
Global Const SIZE_W_E = 9              ' 9 - Size W E
Global Const UP_ARROW = 10             ' 10 - Up Arrow
Global Const HOURGLASS = 11            ' 11 - Hourglass
Global Const NO_DROP = 12              ' 12 - No drop

' ScaleMode (form, picture box, Printer)
Global Const USER = 0                  ' 0 - User
Global Const TWIPS = 1                 ' 1 - Twip
Global Const POINTS = 2                ' 2 - Point
Global Const PIXELS = 3                ' 3 - Pixel
Global Const CHARACTERS = 4            ' 4 - Character
Global Const INCHES = 5                ' 5 - Inch
Global Const MILLIMETERS = 6           ' 6 - Millimeter
Global Const CENTIMETERS = 7           ' 7 - Centimeter

' ScrollBar (text box)
' Global Const NONE = 0                ' 0 - None
Global Const HORIZONTAL = 1            ' 1 - Horizontal
Global Const VERTICAL = 2              ' 2 - Vertical
Global Const BOTH = 3                  ' 3 - Both

' Value (check box)
Global Const UNCHECKED = 0             ' 0 - Unchecked
Global Const CHECKED = 1               ' 1 - Checked
Global Const GRAYED = 2                ' 2 - Grayed

' WindowState (form)
Global Const NORMAL = 0                ' 0 - Normal
Global Const MINIMIZED = 1             ' 1 - Minimized
Global Const MAXIMIZED = 2             ' 2 - Maximized
' ShowWindow() Commands
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_NORMAL = 1
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_MAXIMIZE = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_MINIMIZE = 6
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_RESTORE = 9


'***********************************************
' VB LAN Manager Toolkit function declarations.
'
' Utility function I threw in (mkj)
'
Declare Function wTimeToAsc Lib "wutils.dll" (ByVal ltime&, ByVal szTime$, ByVal length%, ByVal fmat%) As Integer
'
' Windows DLL function declarations
'
Declare Function FindWindow Lib "user" (Class As Any, Caption As Any) As Integer
Declare Function GetModuleHandle Lib "kernel" (ByVal modName$) As Integer
Declare Function ShowWindow Lib "user" (ByVal hWnd%, ByVal cmdShow%) As Integer
Declare Function GetPrivateProfileString Lib "kernel" (ByVal appName$, ByVal keyName$, ByVal default$, ByVal rstr$, ByVal size%, ByVal filename$) As Integer
Declare Function GetPrivateProfileInt Lib "kernel" (ByVal appName$, ByVal keyName$, ByVal default%, ByVal filename$) As Integer
Declare Function WritePrivateProfileString Lib "kernel" (ByVal appName$, ByVal keyName$, ByVal AStr$, ByVal filename$) As Integer
Declare Function GlobalAlloc Lib "kernel" (ByVal wFlags%, ByVal dwBytes&) As Integer
Declare Function GlobalLock Lib "kernel" (ByVal hMem%) As Long
Declare Function GlobalUnlock Lib "kernel" (ByVal hMem%) As Integer
Declare Function GlobalFree Lib "kernel" (ByVal hMem%) As Integer


'
'  DLL function declarations
'

Declare Function EnumBufferToVBArray Lib "vblanman.dll" (Dest As Any, ByVal DestLen%, ByVal Src&, ByVal SrcLen%, ByVal FormatString$, ByVal NumEnts%) As Integer
Declare Function VBTypeToBuffer Lib "vblanman.dll" (ByVal Dest&, ByVal DestLen%, Src As Any, ByVal SrcLen%, ByVal FormatString$) As Integer
Declare Function BufferToVBType Lib "vblanman.dll" (Dest As Any, ByVal DestLen%, ByVal Src&, ByVal SrcLen%, ByVal FormatString$) As Integer
Declare Function CreateLMBuffer Lib "vblanman.dll" (ByVal FormatString$, ByVal Entries%, BufferSize%) As Long
Declare Function FreeLMBuffer Lib "vblanman.dll" (ByVal BufferPointer&) As Integer
Declare Function CFormatSize Lib "vblanman.dll" (ByVal FormatString$, ByVal Flag%) As Integer
Declare Function LMError$ Lib "vblanman.dll" Alias "LMError$" (ByVal ErrorCode%)

'*                                                                  *
'*  About this file ...  NETCONS.TXT                                *
'*                                                                  *

Global Const CNLEN = 15             '* Computer name length     *

Global Const UNCLEN = 17   '* UNC computer name length *
Global Const NNLEN = 12             '* 8.3 Net name length      *
Global Const RMLEN = 30 '* Maximum remote name length *


Global Const SNLEN = 15             '* Service name length      *
Global Const STXTLEN = 63                   '* Service text length      *

Global Const PATHLEN = 260

Global Const DEVLEN = 8                     '* Device name length       *

Global Const DNLEN = CNLEN                  '* Maximum domain name length *
Global Const EVLEN = 16             '* event name length        *
Global Const JOBSTLEN = 80                  '* status length in print job *
Global Const AFLEN = 64                     '* Maximum length of alert  *
                                            '* names field              *
Global Const UNLEN = 20             '* Maximum user name length *
Global Const GNLEN = UNLEN                  '* Group name               *
Global Const PWLEN = 14             '* Maximum password length  *
Global Const SHPWLEN = 8                    '* Share password length    *
Global Const CLTYPE_LEN = 12                '* Length of client type string *


Global Const MAXCOMMENTSZ = 48              '* server & share comment length *

Global Const QNLEN = 12             '* Queue name maximum length     *
Global Const PDLEN = 8              '* Print destination length      *
Global Const DTLEN = 9              '* Spool file data type          *
                                            '* e.g. IBMQSTD,IBMQESC,IBMQRAW  *
Global Const ALERTSZ = 128                 '* size of alert string in server *
'*** ??? how do we want to handle sizeof (int)
Global Const INTSIZE = 2
Global Const LONGSIZE = 4
Global Const SINGLESIZE = 4
Global Const DOUBLESIZE = 8

Global Const MAXDEVENTRIES = 16    '* Max number of device entries   *
                                            '* We use int bitmap to represent *

Global Const HOURS_IN_WEEK = 168         '* for struct user_info_2 in UAS *
Global Const MAXWORKSTATIONS = 8            '* for struct user_info_2 in UAS *

Global Const NETBIOS_NAME_LEN = 16          '* NetBIOS net name *



'*
'*      Constants used with encryption
'*

Global Const CRYPT_KEY_LEN = 7
Global Const CRYPT_TXT_LEN = 8
Global Const ENCRYPTED_PWLEN = 16
Global Const SESSION_PWLEN = 24
Global Const SESSION_CRYPT_KLEN = 21

'*
'*  Value to be used with SetInfo calls to allow setting of all
'*  settable parameters (parmnum zero option)
'*
Global Const PARMNUM_ALL = 0


Global Const NULL = 0


Global Const PUNAVAIL = NULL





'*                                                                  *
'*  About this file ...  SERVER.TXT                                 *
'*                                                                  *


'****************************************************************
'*                                                              *
'*              Function prototypes                             *
'*                                                              *
'****************************************************************

Declare Function NetServerEnum2 Lib "NETAPI.DLL" (ByVal pszServer As String, ByVal sLevel%, ByVal pbBuffer As Long, ByVal cbBuffer%, EntriesRead%, TotalAvail%, ByVal ServerType As Long, ByVal Domain As String) As Integer

Declare Function NetServerGetInfo Lib "NETAPI.DLL" (ByVal pszServer As String, ByVal sLevel As Integer, ByVal pbBuffer As Long, ByVal cbBuffer As Integer, pcbTotalAvail As Integer) As Integer

Declare Function NetServerSetInfo Lib "NETAPI.DLL" (ByVal pszServer As String, ByVal sLevel As Integer, ByVal pbBuffer As String, ByVal cbBuffer As Integer, ByVal sParmNum As Integer) As Integer


'****************************************************************
'*                                                              *
'*              Data structure templates                        *
'*                                                              *
'****************************************************************

Type server_info_0
    sv0_name As String * CNLEN  '* Server name              *
End Type         '* server_info_0 *

Global Const FMT_server_info_0 = "S15"


Type server_info_1
    sv1_name As String * CNLEN
    sv1_version_major As String * 1             '* Major version # of net   *
    sv1_version_minor As String * 1             '* Minor version # of net   *
    sv1_type As Long                            '* Server type              *
    sv1_comment As String * MAXCOMMENTSZ        '* Exported server comment  *
End Type         '* server_info_1 *

Global Const FMT_server_info_1 = "S15B1B1LP48"


Type server_info_2
    sv2_name As String * CNLEN
    sv2_version_major As String * 1
    sv2_version_minor As String * 1
    sv2_type As Long
    sv2_comment As String * MAXCOMMENTSZ
    sv2_ulist_mtime As Long'* User list, last modification time    *
    sv2_glist_mtime As Long '* Group list, last modification time   *
    sv2_alist_mtime As Long '* Access list, last modification time  *
    sv2_users As Integer       '* max number of users allowed          *
    sv2_disc As Integer     '* auto-disconnect timeout(in minutes)  *
    '*** ??? unknown alert username max number(username separated by space)
    sv2_alerts As String * 21 '* ??? * alert names (semicolon separated)    *
    sv2_security As Integer    '* SV_USERSECURITY or SV_SHARESECURITY  *
    sv2_auditing As Integer    '* 0 = no auditing; nonzero = auditing  *
    sv2_numadmin As Integer    '* max number of administrators allowed *
    sv2_lanmask As Integer     '* bit mask representing the srv'd nets *
    sv2_hidden As Integer      '* 0 = visible; nonzero = hidden        *
    sv2_announce As Integer    '* visible server announce rate (sec)   *
    sv2_anndelta As Integer    '* announce randomize interval (sec)    *
                               '* name of guest account                *
    sv2_guestacct As String * UNLEN
    sv2_pad1 As String * 1          '* Word alignment pad byte              *
    sv2_userpath As String * PATHLEN '* ASCIIZ path to user directories      *
    sv2_chdevs As Integer      '* max # shared character devices       *
    sv2_chdevq As Integer      '* max # character device queues        *
    sv2_chdevjobs As Integer   '* max # character device jobs          *
    sv2_connections As Integer '* max # of connections              *
    sv2_shares As Integer           '* max # of shares                      *
    sv2_openfiles As Integer   '* max # of open files               *
    sv2_sessopens As Integer   '* max # of open files per session           *
    sv2_sessvcs As Integer     '* max # of virtual circuits per client *
    sv2_sessreqs As Integer    '* max # of simul. reqs. from a client  *
    sv2_opensearch As Integer   '* max # of open searches                   *
    sv2_activelocks As Integer '* max # of active file locks           *
    sv2_numreqbuf As Integer   '* number of server (standard) buffers  *
    sv2_sizreqbuf As Integer   '* size of svr (standard) bufs (bytes)  *
    sv2_numbigbuf As Integer   '* number of big (64K) buffers          *
    sv2_numfiletasks As Integer'* number of file worker processes      *
    sv2_alertsched As Integer  '* alert counting interval (minutes)    *
    sv2_erroralert As Integer  '* error log alerting threshold         *
    sv2_logonalert As Integer  '* logon violation alerting threshold   *
    sv2_accessalert As Integer '* access violation alerting threshold  *
    sv2_diskalert As Integer   '* low disk space alert threshold (KB)  *
    sv2_netioalert As Integer  '* net I/O error ratio alert threshold  *
                               '*  (tenths of a percent)               *
    sv2_maxauditsz As Integer  '* Maximum audit file size (KB)        *
    '*** ??? server heuristics is 20 digit long described appendix G
    sv2_srvheuristics As String * 20 '* performance related server switches*
End Type        '* server_info_2 *

'BUG BUG We don't know how long the alerts string is
'BUG BUG and performance related server switches length
Global Const FMT_server_info_2 = "S15B1B1LP48LLLIIP??IIIIIIIS20B1B260IIIIIIIIIIIIIIIIIIIIIIB20"

Type server_info_3
    sv3_name As String * CNLEN
    sv3_version_major As String * 1
    sv3_version_minor As String * 1
    sv3_type As Long
    sv3_comment As String * MAXCOMMENTSZ
    sv3_ulist_mtime As Long '* User list, last modification time    *
    sv3_glist_mtime As Long '* Group list, last modification time   *
    sv3_alist_mtime As Long '* Access list, last modification time  *
    sv3_users As Integer             '* max number of users allowed          *
    sv3_disc As Integer     '* auto-disconnect timeout(in minutes)  *
    '*** ??? unknown max alerts for server username
    sv3_alerts As String * 160     '*** ??? alert names (semicolon separated)    *
    sv3_security As Integer    '* SV_USERSECURITY or SV_SHARESECURITY  *
    sv3_auditing As Integer    '* 0 = no auditing; nonzero = auditing  *
    sv3_numadmin As Integer    '* max number of administrators allowed *
    sv3_lanmask As Integer     '* bit mask representing the srv'd nets *
    sv3_hidden As Integer      '* 0 = visible; nonzero = hidden        *
    sv3_announce As Integer    '* visible server announce rate (sec)   *
    sv3_anndelta As Integer    '* announce randomize interval (sec)    *
                   '* name of guest account             *
    sv3_guestacct As String * UNLEN
    sv3_pad1 As String * 1          '* Word alignment pad byte              *
    sv3_userpath As String * PATHLEN '* ASCIIZ path to user directories      *
    sv3_chdevs As Integer      '* max # shared character devices             *
    sv3_chdevq As Integer      '* max # character device queues      *
    sv3_chdevjobs As Integer   '* max # character device jobs        *
    sv3_connections As Integer '* max # of connections              *
    sv3_shares As Integer     '* max # of shares                            *
    sv3_openfiles As Integer   '* max # of open files               *
    sv3_sessopens As Integer   '* max # of open files per session     *
    sv3_sessvcs As Integer     '* max # of virtual circuits per client *
    sv3_sessreqs As Integer    '* max # of simul. reqs. from a client  *
    sv3_opensearch As Integer  '* max # of open searches                    *
    sv3_activelocks As Integer '* max # of active file locks         *
    sv3_numreqbuf As Integer   '* number of server (standard) buffers  *
    sv3_sizreqbuf As Integer   '* size of svr (standard) bufs (bytes)  *
    sv3_numbigbuf As Integer   '* number of big (64K) buffers        *
    sv3_numfiletasks As Integer'* number of file worker processes      *
    sv3_alertsched As Integer  '* alert counting interval (minutes)    *
    sv3_erroralert As Integer  '* error log alerting threshold       *
    sv3_logonalert As Integer  '* logon violation alerting threshold   *
    sv3_accessalert As Integer '* access violation alerting threshold  *
    sv3_diskalert As Integer   '* low disk space alert threshold (KB)  *
    sv3_netioalert As Integer  '* net I/O error ratio alert threshold  *
                   '*  (tenths of a percent)               *
    sv3_maxauditsz As Integer  '* Maximum audit file size (KB)       *
    '*** ??? server heuristics contains 20 digits
    sv3_srvheuristics As String * 20 '* performance related server switches*
    sv3_auditedevents As Long '* Audit event control mask            *
    sv3_autoprofile As Integer '* (0,1,2,3) = (NONE,LOAD,SAVE,or BOTH) *
    sv3_autopath As String * PATHLEN '* file pathname (where to load & save) *
End Type        '* server_info_3 *

'BUG BUG We don't know how long the alerts string is
Global Const FMT_server_info_3 = "S15B1B1LP48LLLIIP160IIIIIIIS20B1P260IIIIIIIIIIIIIIIIIIIIIIP20LIP260"

'****************************************************************
'*                                                              *
'*              Special values and constants                    *
'*                                                              *
'****************************************************************

'*
'*      Mask to be applied to svX_version_major in order to obtain
'*      the major version number.
'*

Global Const MAJOR_VERSION_MASK = &HF

'*
'*      Bit-mapped values for svX_type fields. X = 1, 2 or 3.
'*

Global Const SV_TYPE_WORKSTATION = &H1
Global Const SV_TYPE_SERVER = &H2
Global Const SV_TYPE_SQLSERVER = &H4
Global Const SV_TYPE_DOMAIN_CTRL = &H8
Global Const SV_TYPE_DOMAIN_BAKCTRL = &H10
Global Const SV_TYPE_TIME_SOURCE = &H20
Global Const SV_TYPE_AFP = &H40
Global Const SV_TYPE_NOVELL = &H80
Global Const SV_TYPE_ALL = &HFFFFFFFF   '* handy for NetServerEnum2 *


'*
'*      Values of svX_hidden field. X = 2 or 3.
'*

Global Const SV_HIDDEN = 1
Global Const SV_VISIBLE = 0



'*                                                                  *
'*  About this file ...  NETSTATS.TXT                               *
'*                                                                  *

   
'***************************************************************
'*                                                              *
'*              Function prototypes                             *
'*                                                              *
'****************************************************************

Declare Function NetStatisticsClear Lib "NETAPI.DLL" (ByVal pszServer As String) As Integer

Declare Function NetStatisticsGet Lib "NETAPI.DLL" (ByVal pszServer As String, ByVal pbBuffer As Long, ByVal cbBuffer As Integer, pcbReturned As Integer, pcbTotalAvail As Integer) As Integer

Declare Function NetStatisticsGet2 Lib "NETAPI.DLL" (ByVal pszServer As String, ByVal pszService$, ByVal ulReserved&, ByVal sLevel%, ByVal flOptions&, ByVal pbBuffer As Long, ByVal cbBuffer As Integer, pcbTotalAvail As Integer) As Integer


'***************************************************************
'*                                                              *
'*              Special values and constants                    *
'*                                                              *
'****************************************************************


Global Const STATSOPT_CLR = 1
Global Const STATS_NO_VALUE = -1&
Global Const STATS_OVERFLOW = -2&


'***************************************************************
'*                                                              *
'*              Data structure templates                        *
'*                                                              *
'****************************************************************

Type statistics_info_0
    st0_start As Long         '* time statistics collection started   *
    st0_wknumNCBs As Long     '* # workstation NCBs issued            *
    st0_wkfiNCBs As Long      '* # workstation NCBs failed issue      *
    st0_wkfcNCBs As Long      '* # workstation NCBs failed completion *
    st0_wksesstart As Long    '* # workstation sessions started       *
    st0_wksessfail As Long    '* # workstation session failures       *
    st0_wkuses As Long        '* # workstation uses                   *
    st0_wkusefail As Long     '* # workstation use failures           *
    st0_wkautorec As Long     '* # workstation auto-reconnects        *
    st0_rdrnumNCBs As Long    '* # redir NCBs issued                  *
    st0_srvnumNCBs As Long    '* # NCBs issued for the server         *
    st0_usrnumNCBs As Long    '* # user NCBs issued                   *
    st0_reserved4 As Long     '* reserved for future use              *
    st0_reserved5 As Long     '* reserved for future use              *
    st0_reserved6 As Long     '* reserved for future use              *
    st0_reserved7 As Long     '* reserved for future use              *
    st0_reserved8 As Long     '* reserved for future use              *
    st0_svfopens As Long      '* # of server file opens               *
    st0_svdevopens As Long    '* # of server device opens             *
    st0_svjobsqueued As Long  '* # of server print jobs spooled       *
    st0_svsopens As Long      '* # of server session starts           *
    st0_svstimedout As Long   '* # of server session auto-disconnects *
    st0_svserrorout As Long   '* # of server sessions errored out     *
    st0_svpwerrors As Long    '* # of server password violations      *
    st0_svpermerrors As Long  '* # of server access permission errors *
    st0_svsyserrors As Long   '* # of server system errors            *
    st0_svbytessent As Long   '* # of server bytes sent to net        *
    st0_svbytesrcvd As Long   '* # of server bytes received from net  *
    st0_svavresponse As Long  '* average server response time in msec *
End Type  'statistics_info_0 *

Global Const FMT_statistics_info_0 = "LLLLLLLLLLLLLLLLLLLLLLLLLLLLL"


Type stat_workstation_0
        stw0_start As Long
        stw0_numNCB_r As Long
        stw0_numNCB_s As Long
        stw0_numNCB_a As Long
        stw0_fiNCB_r As Long
        stw0_fiNCB_s As Long
        stw0_fiNCB_a As Long
        stw0_fcNCB_r As Long
        stw0_fcNCB_s As Long
        stw0_fcNCB_a As Long
        stw0_sesstart As Long
        stw0_sessfailcon As Long
        stw0_sessbroke As Long
        stw0_uses As Long
        stw0_usefail As Long
        stw0_autorec As Long
        stw0_bytessent_r_lo As Long
        stw0_bytessent_r_hi As Long
        stw0_bytesrcvd_r_lo As Long
        stw0_bytesrcvd_r_hi As Long
        stw0_bytessent_s_lo As Long
        stw0_bytessent_s_hi As Long
        stw0_bytesrcvd_s_lo As Long
        stw0_bytesrcvd_s_hi As Long
        stw0_bytessent_a_lo As Long
        stw0_bytessent_a_hi As Long
        stw0_bytesrcvd_a_lo As Long
        stw0_bytesrcvd_a_hi As Long
        stw0_reqbufneed As Long
        stw0_bigbufneed As Long
End Type  'stat_workstation_0 *

Global Const FMT_stat_workstation_0 = "LLLLLLLLLLLLLLLLLLLLLLLLLLLLLL"


Type stat_server_0
        sts0_start As Long
        sts0_fopens As Long
        sts0_devopens As Long
        sts0_jobsqueued As Long
        sts0_sopens As Long
        sts0_stimedout As Long
        sts0_serrorout As Long
        sts0_pwerrors As Long
        sts0_permerrors As Long
        sts0_syserrors As Long
        sts0_bytessent_low As Long
        sts0_bytessent_high As Long
        sts0_bytesrcvd_low As Long
        sts0_bytesrcvd_high As Long
        sts0_avresponse As Long
        sts0_reqbufneed As Long
        sts0_bigbufneed As Long
End Type  'stat_server_0 *

Global Const FMT_stat_server_0 = "LLLLLLLLLLLLLLLLL"


'************ End VB custom control stuff **********************

Global Const MAX_STATS = 15 'maximum diff. stats collecting
Global Const MAX_SERVERS = 10 'maximum # of servers to gather stats from
'*****
'** constants to tell which stats to collect.  They are AND'd in the
'** lstats element
'*****
Global Const START = &H1
Global Const BYTESRCVD = &H2
Global Const BYTESSENT = &H4
Global Const AVRESPONSE = &H8
Global Const FOPENS = &H10
Global Const DEVOPENS = &H20
Global Const JOBSQUEUED = &H40
Global Const BIGBUFNEED = &H80
Global Const REQBUFNEED = &H100
Global Const SOPENS = &H200
Global Const STIMEDOUT = &H400
Global Const SERROROUT = &H800
Global Const SYSERRORS = &H1000
Global Const PWERRORS = &H2000
Global Const PERMERRORS = &H4000
Global Const NERR_InvalidAPI = 2142
Global Const ERROR_INVALID_LEVEL = 124
Global Const INI_FILE = "NinfoVB.ini"
Global Const XLS_FILE = "NinfoVB.xls"
Global Const XLM_FILE = "NinfoVB.xlm"
Global Const EXCEL_FILE = "excel.exe"
Global Const NO_INI_FILE = "NinfoVB.ini is not in your Windows path!"


'*****
'* left out of CONSTANT.TXT
'*****
Global Const DDE_NO_APP = 282

'****
'** NOTE: wanted to Dim from 0 to MAX_STATS - 1 but kept
'**       getting the error, "Expression not allowed here..."
'****
Global statsConst(0 To 14) As Long
Global statsName(0 To 14) As String
Global statsLabel(0 To 14) As String
Global lstats(MAX_SERVERS) As Long
Global intervals As Integer
Global intervalTime As Integer
Global clearstats(MAX_SERVERS) As Integer
Global serverinfolevel As Integer
Global server3 As server_info_3
Global wserver As Integer

